require "uuid"

Sequel.migration do
  change do
    create_table :mailboxes do
      column :id,           :uuid, primary_key: true
      foreign_key :user_id, :users, type: :uuid, null: false, on_delete: :cascade
      column :uid,          Integer, null: false
      column :mails_next_uid, Integer, null: false, default: 1
      column :path,         String, null: false, fixed: true, size: 64, default: "INBOX"
      column :updated_at,   DateTime
      column :created_at,   DateTime

      index :path
      index [:user_id, :path], unique: true
      index [:id, :mails_next_uid], unique: true
    end
  end
end
