Sequel.migration do
  change do
    create_table :mails do
      column :id,              :uuid, primary_key: true
      foreign_key :user_id,    :users, type: :uuid, null: false, on_delete: :cascade
      foreign_key :mailbox_id, :mailboxes, type: :uuid, null: false #, on_delete: :cascade
      column :uid,             Integer, null: false
      column :flag_seen,       TrueClass, default: false
      column :flag_draft,      TrueClass, default: false
      column :flag_deleted,    TrueClass, default: false
      column :flag_flagged,    TrueClass, default: false
      column :flag_anwsered,   TrueClass, default: false
      column :flag_recent,     TrueClass, default: false
      column :updated_at,      DateTime
      column :created_at,      DateTime
      column :raw,             String, null: false, default: ""
      column :headers,         String, null: false, default: ""

      index :flag_seen
      index :flag_draft
      index :flag_deleted
      index :flag_flagged
      index :flag_anwsered
      index :flag_recent
      index [:user_id, :mailbox_id, :uid], unique: true
      index :headers, type: :full_text
    end
  end
end
