class ImapServer
  class ClientHandler
    module Login
      def handle_login(msg:, user:)
        if msg.args.size == 2
          handle_login_validation(msg: msg)
        else
          msg.respond ServerMessage.new("NO #{msg.args.size} invalid amount of arguments, require 2", tag: msg.tag)
        end
      end

      private

      def handle_login_validation(msg:)
        username, password = msg.args
        if msg.handler.authenticate_user!(username: username, password: password)
          msg.respond ServerMessage.new("OK connection succeed for #{username}", tag: msg.tag)
        else
          msg.respond ServerMessage.new("BAD connection failure for #{username}", tag: msg.tag)
        end
      end

    end
  end
end
