require_relative "token_parser"

class ImapServer
  # Parse a message as a "<tag> <command> <*args>"
  class ClientMessage
    attr_accessor :tag, :command, :args
    def initialize(tag:, command:, args:)
      @tag = tag
      @command = command
      @args = args
    end

    def self.parse(string)
      # quote_enabled = false
      # escape_enabled = false
      # parts = []
      # current_part = []
      # string.each_grapheme_cluster do |graph|
      #   if escape_enabled
      #     current_part << graph
      #     escape_enabled = false
      #   elsif graph == '\\'
      #     escape_enabled = true
      #   elsif graph == '"'
      #     quote_enabled = quote_enabled == false
      #   elsif graph == " "
      #     if quote_enabled == true
      #       current_part << graph
      #     else
      #       parts << current_part.join("")
      #       current_part = []
      #     end
      #   else
      #     current_part << graph
      #   end
      # end
      # parts << current_part.join("")

      parts = TokenParser.parse_tokens(string)
      raise "Not a valid client message \"#{string}\", missing some parts" if parts.size < 2

      parts[1].downcase!
      ClientMessage.new(
        tag: parts[0],
        command: parts[1],
        args: parts[2..],
      )
    end

    # enable respond and next
    def with(client_handler)
      @handler = client_handler
      self
    end

    attr_accessor :handler

    # send one message back
    def respond(server_message)
      if @handler
        @handler.write server_message.to_s
      else
        raise "No client_handler set"
      end
    end

    # get one new message
    def next(parse: true)
      client_input = @handler.read
      if client_input
        if parse
          ClientMessage.parse(client_input).with(@handler)
        else
          client_input
        end
      else
        raise "Connection terminated by client"
      end
    end

    def error_need_loggin
      respond ServerMessage.new("BAD invalid request, login required", tag: @tag) # TODO err code
    end

  end
end
