require "uuid"

class User < Sequel::Model($db)
  one_to_many :mailboxes

  def before_create
    self.created_at ||= Time.now
    self.id = UUID.generate
    super
  end

  def before_save
    self.updated_at ||= Time.now
    super
  end

  def self.authenticate(username:, password:)
    if (user = User.first(name: username, password: password))
      user
    else
      nil
    end
  end
end
